#define F_CPU 6000000UL

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

//   D     clock  data 
#define clock 3
#define data 2

//   B      PentEVO
#define up  1
#define down  4
#define left  0
#define right  2
#define fire  3

//    Portb.5
#define led 5 

//    
#define speed 150 // 2-> (~282), 254->  (~3.3), 
                  //  speed=150 -> ~6 (      
				  //     

unsigned char buttons[16];
unsigned char i, sum, turbo;


int main(void)
{
  //   /
  DDRB |= (1<<up)|(1<<down)|(1<<left)|(1<<right)|(1<<fire);
  DDRD |= (1<<clock);
  DDRD &=~(1<<data);
  DDRD |= (1<<led); //  

  PORTD &=~(1<<clock);
  PORTB |= (1<<up)|(1<<down)|(1<<left)|(1<<right)|(1<<fire);
  PORTD &=~(1<<led);

  //    ,   
  for (i=0;i<10; i++)
   {
    PORTD |= (1<<led);
    _delay_ms(50);
    PORTD &=~(1<<led);
    _delay_ms(50);
   }
 
 //  
 while(1)
 {
  //      
  PORTD |= (1<<clock);
  _delay_us(500);
  PORTD &=~(1<<clock);
  _delay_us(250);
  buttons[0] = (PIND & (1<<data));
  _delay_us(240);

  //   15      ,
  //     buttons[]
  for (i=1; i<16; i++)
  {
   PORTD |= (1<<clock);
   _delay_us(4);
   PORTD &=~(1<<clock);
   _delay_us(3);
   buttons[i] = (PIND & (1<<data));
  }

 //        
 if (buttons[0]>0 && buttons[1]==0 && buttons[2]==0 && buttons[14]==0 && buttons[15]==0) 
   { 
    //          ,   - 
	//    
	sum =0;
    for (i=3; i<14; i++)
   {
     sum += buttons[i];
   }
   if (sum>0)
    { PORTD |= (1<<led);}
	else
	{ PORTD &=~(1<<led);}

  //           
  if (buttons[3] >0) {PORTB &=~(1<<down);} else {PORTB |= (1<<down);}
  if (buttons[4] >0) {PORTB &=~(1<<up);} else {PORTB |= (1<<up);}
  if (buttons[5] >0) {PORTB &=~(1<<right);} else {PORTB |= (1<<right);}
  if (buttons[6] >0) {PORTB &=~(1<<left);} else {PORTB |= (1<<left);}
  
  //         
  if (buttons[7] >0) {PORTB &=~(1<<fire);} else {if (buttons[8]==0) PORTB |= (1<<fire);}
  
  //    turbo     speed
  //      . 
  if (buttons[8] >0) 
     {
	 turbo++;
	 if (turbo > speed) {turbo=0;}
	 if (turbo > (speed/2)){PORTB &=~(1<<fire);} else {PORTB |= (1<<fire);}
	 } 
	 else 
	 {turbo = 0;}
   }

	else
	//  ,     
	{ for (i=0;i<6; i++)
       {
        PORTD |= (1<<led);
        _delay_ms(30);
        PORTD &=~(1<<led);
        _delay_ms(30);
       }
    }

 
    

 } //   
} //  
