#define F_CPU 12000000UL

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

//   D     clock  data 
#define clock 2
#define data 3
#define latch 4

//         PentEVO
#define up  0
#define down  1
#define left  2
#define right  3
#define fire  4

//    Portb.5
#define led 5 

unsigned char buttons[9];
unsigned char i, sum;

int main(void)
{
  //   /
  DDRB |= (1<<up)|(1<<down)|(1<<left)|(1<<right)|(1<<fire);
  DDRD |= (1<<clock);
  DDRD |= (1<<latch);
  DDRD &=~(1<<data);
  DDRD |= (1<<led); //  

  PORTD &=~(1<<clock);
  PORTD &=~(1<<latch);
  PORTB |= (1<<up)|(1<<down)|(1<<left)|(1<<right)|(1<<fire);
  PORTD &=~(1<<led);

  //    ,   
  for (i=0;i<10; i++)
   {
    PORTD |= (1<<led);
    _delay_ms(50);
    PORTD &=~(1<<led);
    _delay_ms(50);
   }
 
 //  
 while(1)
 {
   //      
   PORTD |=(1<<latch);
   _delay_us(500);
   PORTD &=~(1<<latch);
   _delay_us(500);
   //     ("")
   buttons[0] = (PIND & (1<<data));
  
   //       :
   // "B", "Select", "Start", "", "", "", "" 
   for (i=1; i<8; i++)
       {
	    PORTD |=(1<<clock);
        _delay_us(200);
		PORTD &=~(1<<clock);
		_delay_us(200);
        buttons[i] = (PIND & (1<<data));
		}

    //       ,   
	sum =0;
    for (i=0; i<8; i++)
   {
     if (buttons[i]==0) {sum++;}
   }
   if (sum>0)
    { PORTD |= (1<<led);}
	else
	{ PORTD &=~(1<<led);} 

   //           
   // !      ,    
   /*
   //    
  if (buttons[5]>0) {PORTB &=~(1<<down);} else {PORTB |= (1<<down);}
  if (buttons[4]>0) {PORTB &=~(1<<up);} else {PORTB |= (1<<up);}
  if (buttons[7]>0) {PORTB &=~(1<<right);} else {PORTB |= (1<<right);}
  if (buttons[6]>0) {PORTB &=~(1<<left);} else {PORTB |= (1<<left);}
  //   buttons[0]  buttons[1],     "",   ""
  if (buttons[0]>0) {PORTB &=~(1<<fire);} else {PORTB |= (1<<fire);}
  */
  //    
  if (buttons[5]==0) {PORTB &=~(1<<down);} else {PORTB |= (1<<down);}
  if (buttons[4]==0) {PORTB &=~(1<<up);} else {PORTB |= (1<<up);}
  if (buttons[7]==0) {PORTB &=~(1<<right);} else {PORTB |= (1<<right);}
  if (buttons[6]==0) {PORTB &=~(1<<left);} else {PORTB |= (1<<left);}
  //   buttons[0]  buttons[1],     "",   ""
  if (buttons[0]==0) {PORTB &=~(1<<fire);} else {PORTB |= (1<<fire);}

		 

 } //   
} //     
